<?php

namespace Drupal\reviewer\Reviewer\Builder;

use Drupal\reviewer\Plugin\reviewer\Review\ReviewPluginInterface;

/**
 * Defines a class to builds arrays of configuration and configuration entities.
 */
interface ConfigBuilderInterface {

  /**
   * Load configuration defined on the review plugin's attributes.
   *
   * If the review plugin is an entity review, the entity's configuration and
   * all dependents will also be loaded.
   *
   * @return array<string, \Drupal\Core\Config\Entity\ConfigEntityInterface|\Drupal\Core\Config\ImmutableConfig>
   *   Configuration keyed by the config ID.
   */
  public function configurationEntities(
    ReviewPluginInterface $review,
    string $bundle = '',
  ): array;

}
