<?php

namespace Drupal\reviewer\Reviewer\Review;

/**
 * Defines a factory which creates reviews.
 */
interface ReviewFactoryInterface {

  /**
   * Create a review.
   *
   * @param array<string, \Drupal\reviewer\Reviewer\Checklist\ChecklistInterface> $checklists
   * @param array<string, \Drupal\Core\Config\Entity\ConfigEntityInterface|\Drupal\Core\Config\ImmutableConfig> $configuration
   * @param array{id: string, reason: string}[] $ignored
   */
  public function create(
    string $id,
    string $label,
    array $checklists,
    array $configuration,
    array $ignored,
  ): ReviewInterface;

}
